#
# To build against different kernel use: --define "kernel_version VERSION-RELEASE"
#

%define srcfile Integration_Components_for_Linux_-__v_2.1.tgz

Name: mshvic
License: BSD/GPLv2
Group: System/Kernel
Summary: Linux Integration Services for Hyper-V (TM)
Version: 2.1.2
Release: 2%{?dist}
Packager: Jaroslaw Polok <jaroslaw.polok@cern.ch>
Vendor: CERN, http://cern.ch/linux
Source0: %{srcfile}
Source1: %{name}-depmod.conf
Source2: %{name}-mkinitrd.conf
BuildRoot: %{_tmppath}/%{name}-%{version}-build
Requires: %{name}-kmod
Provides: %{name}-kmod-common = %{?epoch:%{epoch}:}%{version}

Source1111: slc-kmodtool-mshvic
BuildRequires: %kernel_module_package_buildreqs

%define upvar default
%ifarch i686
%define paevar PAE
%endif
%ifarch i686 ia64 x86_64
%define xenvar xen
%endif

%kernel_module_package -s %{SOURCE1111} %{?upvar} %{?xenvar} %{?paevar}

%description
Linux Integration Services for Hyper-V (TM) in
Windows Server 2008, Windows Server 2008 R2, Microsoft
Hyper-V Server 2008 and Microsoft Hyper-V Server 2008 R2.

Contains drivers for the following:
VMBus
Microsoft synthetic SCSI controller
Microsoft synthetic network adapter

Copyright (c) 2010, Microsoft Corporation.

Version : 2.1.2
Date    : March 31, 2010

%prep
%setup -c -n %{name}-%{version}/
set -- *
mkdir source
mv "$@" source/
mkdir obj

%build
for flavor in %{flavors_to_build} ; do
   rm -rf obj/$flavor
   cp -r source obj/$flavor
   cd obj/$flavor/src/drivers/
   export KERNEL_VER="KERNEL_2_6_18"
   export CPU_TYPE=`/bin/uname -m`
   if [ "$flavor" == "xen" ]; then
    export X2V_LINUX="X2V_LINUX=1"
   else
    export X2V_LINUX="X2V_LINUX=0"
   fi 
   echo "************************************************************"
   make env
   echo "************************************************************"
   make
   make public 
   cd ../../../../
done

%install
for flavor in %flavors_to_build ; do 
   kmodloc="$RPM_BUILD_ROOT/lib/modules/%{kernel_version}"
   if [ "$flavor" != "default" ]; then
    kmodloc="$kmodloc$flavor"
   fi
   kmodloc="$kmodloc/extra"
   cd obj/$flavor/src/drivers/
   install -d -m0755 $kmodloc/
   install -m0755 ./vmbus/vmbus.ko $kmodloc/
   install -m0755 ./blkvsc/blkvsc.ko $kmodloc/
   install -m0755 ./storvsc/storvsc.ko $kmodloc/
   install -m0755 ./netvsc/netvsc.ko $kmodloc/
   cd ../../../../
done
install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/vmbus
install -m0755 obj/default/src/drivers/tools/udev/vmbus.uevent $RPM_BUILD_ROOT/%{_sysconfdir}/vmbus/
install -m0755 obj/default/src/drivers/tools/udev/netvsc.uevent $RPM_BUILD_ROOT/%{_sysconfdir}/vmbus/
install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/udev/rules.d
install -m0644 obj/default/src/drivers/tools/udev/20-vmbus.rules $RPM_BUILD_ROOT/%{_sysconfdir}/udev/rules.d/
#new line for Jan
echo "" >> $RPM_BUILD_ROOT/%{_sysconfdir}/udev/rules.d/20-vmbus.rules
install -m0644 obj/default/src/drivers/tools/udev/20-netvsc.rules $RPM_BUILD_ROOT/%{_sysconfdir}/udev/rules.d/
install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/network-scripts
install -m0644 obj/default/src/drivers/tools/udev/ifcfg-seth $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/network-scripts/ifcfg-seth0
install -m0644 obj/default/src/drivers/tools/udev/ifcfg-seth $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/network-scripts/ifcfg-seth1
install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/
install -m0755 obj/default/src/drivers/tools/init.d/vmbus $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/
install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/depmod.d/
install -m0644 %{SOURCE1} $RPM_BUILD_ROOT/%{_sysconfdir}/depmod.d/%{name}.conf
install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/mkinitrd/
install -m0644 %{SOURCE2} $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/mkinitrd/%{name}
install -d -m0755 $RPM_BUILD_ROOT/usr/sbin
install -m0755 obj/default/src/drivers/tools/scripts/updategrub.pl $RPM_BUILD_ROOT/usr/sbin/mshvic-updategrub.pl
install -m0755 obj/default/src/drivers/tools/scripts/updateinitrd.pl $RPM_BUILD_ROOT/usr/sbin/mshvic-updateinitrd.pl


%clean
rm -rf %{buildroot}

%post
echo "Enable MSHVIC services"
/sbin/chkconfig --add vmbus || :
/sbin/chkconfig --levels 345 vmbus on ||:
/sbin/udevcontrol reload_rules ||:
echo "Add MSHVIC parameters to grub configuration"
/usr/sbin/mshvic-updategrub.pl ||:
echo "Please reboot your system to enable MSHVIC services"

%postun
/sbin/udevcontrol reload_rules ||:

%files
%defattr(-,root,root,-)
%config %{_sysconfdir}/depmod.d/%{name}.conf
%{_sysconfdir}/init.d/vmbus
%config %{_sysconfdir}/sysconfig/mkinitrd/%{name}
%config %{_sysconfdir}/vmbus/vmbus.uevent
%config %{_sysconfdir}/vmbus/netvsc.uevent
%config %{_sysconfdir}/udev/rules.d/20-vmbus.rules
%config %{_sysconfdir}/udev/rules.d/20-netvsc.rules
%config %{_sysconfdir}/sysconfig/network-scripts/ifcfg-seth0
%config %{_sysconfdir}/sysconfig/network-scripts/ifcfg-seth1
/usr/sbin/mshvic-updategrub.pl
/usr/sbin/mshvic-updateinitrd.pl

%doc obj/default/src/LICENSE-DUAL-BSD-GPL obj/default/src/LICENSE-GPL obj/default/src/README obj/default/src/docs/LinuxIC_UserGuide.pdf

%changelog
* Fri Apr 30 2010 Jaroslaw Polok <jaroslaw.polok@cern.ch> 
- initial version
- packaging changed to DUP: http://driverupdateprogram.com/
